<!--#INCLUDE FILE="getListData.inc"-->
<HTML>
<HEAD>
<META NAME="GENERATOR" Content="Microsoft Visual InterDev 1.0">
<META HTTP-EQUIV="Content-Type" content="text/html; =
charset=iso-8859-1">
	<TITLE>URPM Sample</TITLE>
<SCRIPT Language="JavaScript">
//Modified the initLists function to handle values in addition to text

var v = false;

function get(elt)
{
   // loop thru document.forms property and exit w/ current element index

   var num = -1;
   for (var i = 0; i < elt.form.elements.length; i++) {
      if (elt.form.elements[i].name == elt.name) {
        num = i;  // save element index
        break;
      }
   }
   return num;  // returns current element index
}


function sindex(num, offset, elt)
{  //***modified next line to get the right element index***
   // sel finds selected index or value of num + offset's form element
   var sel = elt.form.elements[num+offset].selectedIndex;
   if (sel < 0) sel = 0;

   return sel;
}

function relate(elt, tree, depth)
{ // relate submenus based on sel of form - calls update to redef submenus
   if (v) {
      var num = get(elt); // fetch the current elt index
      var a = tree;        // set a to be the tree array

      while (a != null && --depth != -1) {
        // traverse menu tree until we reach the corresponding option record
        a = a[sindex(num, -depth, elt)];
      }

      // at depth 3, should end up w/ something like a[i][j][k]
      // where each index holds the value of s(elected )index in related form select elts
      if (a != null && a.length) {
         // if a array exists and it has elements,
         // feed update() w/ this record reference
         update(num, elt, a);
         return;
      }
   }
   // if a hasn't any array elements or new Option unsupported then end up here ;)
   //jmp(form, elt); // make like a live popup
}


function update(num, elt, m)
{
   // updates submenus - element(num)'s menu options, and all submenus
   // if refd element exists

   if (num != -1) {
      num++; // reference next element, assume it follows in HTML
      //***modified next line to refer to elements within the same form***
      with (elt.form.elements[num]) {

	 // null out options in reverse order (bug work-around)
         for (var i = options.length - 1; 0 < i; i--) options[i] = null;

         // fill up next menu's items
         for (var i = 0; i < m.length; i++)
           options[i] = (m[i].value != null) ? new Option(m[i].text, m[i].value) : new Option(m[i].text);

         options[0].selected = true; // default to 1st menu item, windows bug kludge
      }
      if (m[0].length != 0) {
         update(num, elt, m[0]); // update subsequent form if any grandchild menu exists
      }
    }
}

// Internet Explorer 4+ bug fix:
// IE4+ remembers the index of each SELECT but NOT the CONTENTS of each SELECT,
// so it gets it wrong.

function resetIE() {
   for (var i = 0; i < document.forms.length; i++) {
      document.forms[i].reset();
   }
}

if (document.all)
   window.onload = resetIE;

function initLists() {

  if (!v) return false;

  var args = initLists.arguments;
  var argLen = args.length - 1;
  var temp = new Array();
  var baseList = args[0];

  fillBaseList( baseList, args[1] );

  //this loop iterates through each 2nd argument (arrays)
  for(var arg=argLen; arg>2; arg-=2) {
    var list = args[arg-1];
    var a = args[arg];
    var newSubI = 0, oldSubI = 0;
    var subMenu = null;

    for(var i=0; i<a.length;i++) {
     if (a[i].length) {
        //create a new Option with the appropriate submenu
        subMenu = arg==argLen ? null : m[oldSubI++];
        temp[temp.length] = typeof(a[i]) == "object"
                            ? new O(a[i][0], a[i][1], subMenu )
           	                : new O(a[i]   , null   , subMenu );
	}
      else {
        temp = temp.sort(compare);
        m[newSubI++] = temp;
        temp = new Array();
      }
    }
    //reset the length of array
    m.length = newSubI;
  }

  //set up the listboxes
  relate(baseList, m, 1);

  return true;
}

function fillBaseList(elt, a) {
  if (v) {
    //create a new Option for each array element
    for(var i=0; i<a.length; i++)
    {
       a[i] = typeof(a[i]) == "object" ? new O( a[i][0], a[i][1], null ) : new O( a[i], null, null );
    }
    //fill the list
    // null out options in reverse order (bug work-around)
    for (var i = elt.options.length - 1; 0 < i; i--)
      elt.options[i] = null;

    // fill up menu's items
    for (var i = 0; i < a.length; i++)
      elt.options[i] = a[i].value != null
                       ? new Option(a[i].text, a[i].value)
                       : new Option(a[i].text);

    elt.options[0].selected = true; // default to 1st menu item, windows bug kludge
  }
}

//this function is used to size the listboxes in Netscape
function getDefaultListItems()
{ 
  if (v && navigator.appName == 'Netscape')
  {
    var options = ""
    for (var i=0; i<10; i++) options += "<Option>.......................</Option>";

    return options;
  }
}

// Internet Explorer 4+ bug fix:
// IE4+ remembers the index of each SELECT but NOT the CONTENTS of each SELECT,
// so it gets it wrong.
//
// Thanks to Peter Belesis (pbel@internet.com) for pointing this out.

function resetIE() {
   for (var i = 0; i < document.forms.length; i++) {
      document.forms[i].reset();
   }
}

if (document.all)
   window.onload = resetIE;

</SCRIPT>
<SCRIPT Language="JavaScript1.2">
// Check if Option constructor is supported
if ((typeof(Option) + "") != "undefined")
{ v = true; }
else
{  alert("This page is best viewed in Netcape or IE 4+."); }

// This constructor works equally well for 2D, and over
function O(text, value, submenu)
{
   this.text = text;
   this.value = value;
   this.length = 0;

   if (submenu != null) {
      // submenu is an array of options...
      for (var i = 0; i < submenu.length; ) {
         this[i] = submenu[i];
         this.length = ++i;
      }
   }
}

//***new function to sort the lists***
function compare(a,b) {
   return (a.text > b.text)? 1 : -1;
}
</SCRIPT>

</HEAD>
<BODY TopMargin="0" Leftmargin="0"
onLoad="initLists(document.frmURPM.Manufacturer, Manufacturer, document.frmURPM.ModelName, Model, document.frmURPM.ModelLevel, Level)">
<!--#INCLUDE FILE="showErrors.inc"-->

<H1 ALIGN=CENTER>Single Form Version</H1>

<H2 ALIGN=CENTER><I>Universal Related Popup Menus</I></H2>

<h3 align="center">Automobile Request Form Example </h3>
<center>
  <form method="get" name="frmURPM" action="showUrl.htm">
    <table bgcolor="#DDCCFF" border="0" cellpadding="8" cellspacing="0">
      <tr valign="TOP">
        <td>
          <p>Choose a manufacturer:<br>
            <br>
            <select name="Manufacturer" id="m1" class=saveHistory onChange="relate(this,m,1)">
                  <SCRIPT Language=JavaScript>
  				document.writeln( getDefaultListItems() );
			</SCRIPT>
            </select>
          </p>
        </td>
        <td bgcolor="#FFFFFF" valign=MIDDLE><b>-&gt;</b></td>
        <td>Choose a model:<br>
          <br>
          <select name="ModelName" id="m2" class=saveHistory onChange="relate(this,m,2)">
            <SCRIPT Language=JavaScript>
  			document.writeln( getDefaultListItems() );
		</SCRIPT>
          </select>
          <br>
        </td>
        <td bgcolor="#FFFFFF" valign=MIDDLE><b>-&gt;</b></td>
        <td>Choose a model level:<br>
          <br>
          <select name="ModelLevel" id="m3" class=saveHistory onChange="relate(this,m,3)">
            <SCRIPT Language=JavaScript>
  			document.writeln( getDefaultListItems() );
		</SCRIPT>
          </select>
        </td>
      </tr>
    </table>
  <input type=submit>
  </form>

</center>

</BODY>
</HTML>
